package cc.fascinated.bat.features.base.commands.fun;

import cc.fascinated.bat.command.BatCommand;
import cc.fascinated.bat.command.Category;
import cc.fascinated.bat.command.CommandInfo;
import cc.fascinated.bat.common.EmbedDescriptionBuilder;
import cc.fascinated.bat.common.EmbedUtils;
import cc.fascinated.bat.common.MathUtils;
import cc.fascinated.bat.model.BatGuild;
import cc.fascinated.bat.model.BatUser;
import lombok.NonNull;
import net.dv8tion.jda.api.entities.Member;
import net.dv8tion.jda.api.entities.User;
import net.dv8tion.jda.api.entities.channel.middleman.MessageChannel;
import net.dv8tion.jda.api.interactions.commands.OptionMapping;
import net.dv8tion.jda.api.interactions.commands.OptionType;
import net.dv8tion.jda.api.interactions.commands.SlashCommandInteraction;
import net.dv8tion.jda.api.interactions.commands.build.OptionData;
import org.springframework.stereotype.Component;

/**
 * @author Fascinated (fascinated7)
 */
@Component
@CommandInfo(
        name = "ppsize",
        description = "Get the size of someone's pp",
        userInstall = true,
        category = Category.FUN
)
public class PPSizeCommand extends BatCommand {
    public PPSizeCommand() {
        super.addOptions(new OptionData(OptionType.USER, "user", "The user you want to get the pp size of", true));
    }

    @Override
    public void execute(BatGuild guild, @NonNull BatUser user, @NonNull MessageChannel channel, Member member, @NonNull SlashCommandInteraction event) {
        OptionMapping userOption = event.getOption("user");
        assert userOption != null; // This should never be null
        User target = userOption.getAsUser();

        int size = (int) MathUtils.random(1, 12);
        event.replyEmbeds(EmbedUtils.genericEmbed()
                .setDescription(new EmbedDescriptionBuilder("PP Size")
                        .appendLine("""
                                The size of %s's pp is %s inches
                                **8%sD**
                                """.formatted(
                                target.getAsMention(),
                                size,
                                "=".repeat(size)
                        ), false)
                        .build())
                .build()).queue();
    }
}
