package cc.fascinated.bat.features.base.commands.general.avatar;

import cc.fascinated.bat.command.BatCommand;
import cc.fascinated.bat.command.Category;
import cc.fascinated.bat.command.CommandInfo;
import cc.fascinated.bat.common.EmbedUtils;
import cc.fascinated.bat.model.BatGuild;
import cc.fascinated.bat.model.BatUser;
import lombok.NonNull;
import net.dv8tion.jda.api.entities.Member;
import net.dv8tion.jda.api.entities.User;
import net.dv8tion.jda.api.entities.channel.middleman.MessageChannel;
import net.dv8tion.jda.api.interactions.commands.OptionMapping;
import net.dv8tion.jda.api.interactions.commands.OptionType;
import net.dv8tion.jda.api.interactions.commands.SlashCommandInteraction;
import net.dv8tion.jda.api.interactions.commands.build.OptionData;
import org.springframework.stereotype.Component;

/**
 * @author Nick (okNick)
 */
@Component("avatar:user.sub")
@CommandInfo(name = "user", description = "View the avatar of a user", guildOnly = false, category = Category.GENERAL)
public class UserSubCommand extends BatCommand {
    public UserSubCommand() {
        super.addOptions(new OptionData(OptionType.USER, "user", "The user to view the avatar of", true));
    }

    @Override
    public void execute(BatGuild guild, @NonNull BatUser user, @NonNull MessageChannel channel, Member member, @NonNull SlashCommandInteraction event) {
        OptionMapping userOption = event.getOption("user");
        assert userOption != null;
        User target = userOption.getAsUser();

        event.replyEmbeds(EmbedUtils.genericEmbed()
                .setAuthor("%s's Avatar".formatted(target.getName()), null, target.getEffectiveAvatarUrl())
                .setImage(target.getEffectiveAvatarUrl())
                .build()
        ).queue();
    }
}