package cc.fascinated.bat.features.leveling.command;

import cc.fascinated.bat.command.BatCommand;
import cc.fascinated.bat.command.CommandInfo;
import lombok.NonNull;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Component;

/**
 * @author Fascinated (fascinated7)
 */
@Component
@CommandInfo(
        name = "leveling",
        description = "The main command for the leveling feature"
)
public class LevelingCommand extends BatCommand {
    @Autowired
    public LevelingCommand(@NonNull ApplicationContext context) {
        super.addSubCommands(
                context.getBean(CurrentSubCommand.class),
                context.getBean(ChannelSubCommand.class),
                context.getBean(ResetSubCommand.class)
        );
    }
}
